/* GNU polyxmass - the massist's program.
   -------------------------------------- 
   Copyright (C) 2000,2001,2002,2003,2004 Filippo Rusconi

   http://www.polyxmass.org

   This file is part of the "GNU polyxmass" project.
   
   The "GNU polyxmass" project is an official GNU project package (see
   www.gnu.org) released ---in its entirety--- under the GNU General
   Public License and was started at the Centre National de la
   Recherche Scientifique (FRANCE), that granted me the formal
   authorization to publish it under this Free Software License.

   This software is free software; you can redistribute it and/or
   modify it under the terms of the GNU  General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This software is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.
   
   You should have received a copy of the GNU  General Public
   License along with this software; if not, write to the
   Free Software Foundation, Inc., 51 Franklin St, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef LIBPOLYXMASS_MASSPAIR_H
#define LIBPOLYXMASS_MASSPAIR_H


#include "libpolyxmass-globals.h"
#include "libpolyxmass-prop.h"
#include "pxmchem-ionizerule.h"


typedef struct _PxmMasspair PxmMasspair;


struct _PxmMasspair
{
  gdouble mono;
  gdouble avg;

  PxmIonizerule *ionizerule;
};
  


/* NEW'ING FUNCTIONS, DUPLICATING FUNCTIONS ...
 */

PxmMasspair *
libpolyxmass_masspair_new (void);

PxmMasspair *
libpolyxmass_masspair_dup (PxmMasspair *mp);

PxmProp *
libpolyxmass_masspair_prop_dup (PxmProp * prop);

gboolean
libpolyxmass_masspair_set_mono (PxmMasspair *mp, gdouble mono);

gboolean
libpolyxmass_masspair_set_avg (PxmMasspair *mp, gdouble avg);

gboolean
libpolyxmass_masspair_set_both (PxmMasspair *mp, gdouble mono, gdouble avg);

gdouble
libpolyxmass_masspair_get_mono (PxmMasspair *mp);

gdouble
libpolyxmass_masspair_get_avg (PxmMasspair *mp);




/*  LOCATING FUNCTIONS
 */




/* UTILITY FUNCTIONS
 */
gboolean
libpolyxmass_masspair_reset (PxmMasspair *mp);






/* FREE'ING FUNCTIONS
 */
gboolean
libpolyxmass_masspair_free (PxmMasspair *mp);

gint 
libpolyxmass_masspair_prop_free (PxmProp *prop);



/* GPtrArray-RELATED FUNCTIONS
 */
gint
libpolyxmass_masspair_GPA_empty (GPtrArray *GPA);

gint
libpolyxmass_masspair_GPA_free (GPtrArray *GPA);
















#endif





